#############################################################################
# Software Testing Automation Framework (STAF)                              #
# (C) Copyright IBM Corp. 2001                                              #
#                                                                           #
# This software is licensed under the Common Public License (CPL) V1.0.     #
#############################################################################

LIB_TCLSTAF = $(subst Name,TCLSTAF,$(DLL))

stafif_tcl_targets += \
  $(REL)/lib/$(LIB_TCLSTAF) \
  $(REL)/bin/STAF.tcl \
  $(REL)/lib/STAFUtil.tcl \
  $(REL)/lib/pkgIndex.tcl

Targets += $(stafif_tcl_targets)
CleanupTargets += cleanup_stafif_tcl

$(stafif_tcl_targets): SUBSYS_REL := lang/tcl
SUBSYS_REL := lang/tcl

#=====================================================================
#   C/C++ Info Flags
#=====================================================================

$(stafif_tcl_targets)    : INCLUDEDIRS = $(TCL_INCLUDEDIRS)
$(stafif_tcl_targets)    : LIBDIRS     = $(TCL_LIBDIRS)
$(stafif_tcl_targets)    : LIBS        = STAF $(TCL_LIBS)
$(stafif_tcl_targets)    : OBJS        = $(stafif_tcl_objs)

stafif_tcl_objs :=\
  TCLSTAF

stafif_tcl_objs        := $(foreach obj,$(stafif_tcl_objs),$(O)/lang/tcl/$(obj)$(OS_OE))
stafif_tcl_dependents  := $(stafif_tcl_objs:$(OS_OE)=.d)
$(stafif_tcl_dependents): SUBSYS_REL = lang/tcl
$(stafif_tcl_dependents): INCLUDEDIRS = $(TCL_INCLUDEDIRS)

ifeq ($(OS_NAME),win32)
    stafif_tcl_objs += $(SRC)/lang/tcl/TCLSTAF.def
endif


# Include dependencies
ifneq ($(InCleanup), "1")
    include $(stafif_tcl_dependents)
endif

# Include inference rules
include $(InferenceRules)

# STAFIF TCL targets

$(REL)/lib/$(LIB_TCLSTAF): $(stafif_tcl_objs) $(LIB_STAF_FP) $(MAKEFILE_NAME)
	$(SHARED_LIB_IT)

$(REL)/bin/STAF.tcl: $(SR_SRC)/STAF.tcl
	$(COPY_FILE)

$(REL)/lib/STAFUtil.tcl: $(SR_SRC)/STAFUtil.tcl
	$(COPY_FILE)

$(REL)/lib/pkgIndex.tcl: $(SR_SRC)/pkgIndex.tcl
	@echo "*** Generating pkgIndex.tcl ***"
	@cat $< | sed -e 's/LIB_TCLSTAF/$(LIB_TCLSTAF)/;' >$@

cleanup_stafif_tcl:
	-@$(DEL) $(O)/stafif/tcl/* $(OUT_ERR_TO_DEV_NULL)
	-@$(DEL) $(REL)/lib/$(LIB_TCLSTAF) $(OUT_ERR_TO_DEV_NULL)
	-@$(DEL) $(REL)/lib/STAFUtil.tcl $(OUT_ERR_TO_DEV_NULL)
	-@$(DEL) $(REL)/lib/pkgIndex.tcl $(OUT_ERR_TO_DEV_NULL)
